#include <stdlib.h>
#include <string.h>
#include "lcd.h"

#define F_CPU 16000000
#include <util/delay.h>

#define COL2 PB0
#define ROW1 PB1
#define COL1 PB2
#define ROW4 PB3
#define COL3 PB4
#define ROW3 PB5
#define ROW2 PB6

#define ASTERISK 20
#define DIEZ 30

void play();
int key_p();
char letter(int key, int count);

int main()
{
	LCD_init();
	LCD_print("Hello!");
	_delay_ms(150);
   int key = -1;
   
   while (1) { 
	 LCD_print("Incepe Stanzuratoarea!");
	 _delay_ms(150);
	 play();
	 _delay_ms(1000);
	 key = -1;
   }
   return 0;
}

void play()
{
	char cuvant[7] =  "placuta"; 
	int size = 7;
   int key = -1, oldkey = -1, count = 0, viata = 5;
   char guessed[7], begin[] = "-------";
   char lives[] = "Viata: 5";
   char c;
   int found;
   //char *pos;
   int poz;
	
   strncpy(guessed, begin, size);
   
   while (viata > 0) {
		  if (count > 3)
			  count = 1;
			  
			  LCD_print2(lives, guessed);
			  key = key_p();
			  if (key != -1) {
				 if (oldkey != key)
					count = 1;
				 else {
					count++;
				 }
		  } else {
				c = letter(oldkey, count);
				found = 0;
				poz = -1;
				do {
					poz = strchr(cuvant, c);
					if(poz >= 0){
						guessed[poz] = c;
						found = 1;
					}
				} while(poz);
		  }
		  if (!strchr(guessed, '-')) {
				LCD_print("Felicitari ai castigat!");
		 return;
		  }
		  if (!found)
			viata--;
		  _delay_ms(800);
	   }
	   
	   LCD_print("Ai pierdut! Mai mult noroc data viitoare!");
}


int rows[] = {ROW1, ROW2, ROW3, ROW4};
int cols[] = {COL1, COL2, COL3};

int key_p()
{
   PORTB |= (1 << ROW2) | (1 << ROW1) | (1 << ROW3) | (1 << ROW4);  // activam rezistenta de pull-up
  
   DDRB |= (1 << COL1) | (1 << COL2) | (1 << COL3);
   int i, ret = -1;
   
   for (i = 0; i < 3; i++) {
		  switch(i) {
		 case 0: {
			  DDRD |= (1 << COL1);
			  
			  if (!(PINB & (1 << ROW1)))
				 ret = 1;
			  if (!(PINB & (1 << ROW2)))
				 ret = 0;
			  if (!(PINB & (1 << ROW3)))
				 ret = DIEZ;
			  if (!(PINB & (1 << ROW4)))
				 ret = ASTERISK;
			  
			  DDRD &= ~(1<< COL1);
			  return ret;
		 }
		 case 1: {
			  DDRD |= 1 << COL2;  
			  
			  if (!(PINB & (1 << ROW1)))
				 ret = 2;
			  if (!(PINB & (1 << ROW2)))
				 ret = 5;
			  if (!(PINB & (1 << ROW3)))
				 ret = 8;
			  if (!(PINB & (1 << ROW4)))
				 ret = 4;
			  
			  DDRB &= ~(1 << COL2);
			  return ret;
		 }
		 case 3: {
			  DDRB |= 1 << COL3;  
			  
			  if (!(PINB & (1 << ROW1)))
				 ret = 3;
			  if (!(PINB & (1 << ROW2)))
				 ret = 6;
			  if (!(PINB & (1 << ROW3)))
				 ret = 9;
			  if (!(PINB & (1 << ROW4)))
				 ret = 7;
			  
			  DDRB &= ~(1<< COL3);
			  return ret;
		 }
		  }
	   }
	   return ret;
}

char letter(int key, int count)
{
   switch(key) {
      case 2: {
		 switch(count) {
			case 1: return 'a';
			case 2: return 'b';
			case 3: return 'c';
		 }
      }
      case 3: {
		 switch(count) {
			case 1: return 'd';
			case 2: return 'e';
			case 3: return 'f';
		 }
      }
      case 4: {
		 switch(count) {
			case 1: return 'g';
			case 2: return 'h';
			case 3: return 'i';
		 }
      }
      case 5: {
		 switch(count) {
			case 1: return 'j';
			case 2: return 'k';
			case 3: return 'l';
		 }
      }
      case 6: {
		 switch(count) {
			case 1: return 'm';
			case 2: return 'n';
			case 3: return 'o';
		 }
      }
      case 7: {
		 switch(count) {
			case 1: return 'p';
			case 2: return 'r';
			case 3: return 's';
		 }
      }
      case 8: {
		 switch(count) {
			case 1: return 't';
			case 2: return 'u';
			case 3: return 'v';
		 }
      }
      case 9: {
		 switch(count) {
			case 1: return 'x';
			case 2: return 'y';
			case 3: return 'z';
		 }
      }
   }
   return 'a';
}